Smart Proxy - Bug #1967

Failed to list certificates: uninitialized constant Module::Puppet
11/22/2012 05:35 AM - Dmitriy Novitskiy

Status: Closed
Priority: High
Assignee: Dominic Cleal
Category:

Target version: 1.1

Difficulty: Fixed in Releases:
Pull request:

Description

| have problem with smart-proxy and puppet 3:

OS: Centos 5386

puppet: 3.0.1

foreman: 1.0.1-1.el5

foreman-proxy: 1.0.0-3.20121022.el5

after adding smart-proxies i get error: "406 Not Acceptable”

in logs:

E, [2012-11-22T14:30:35.324611 #28312] ERROR -- : Failed to list certificates: uninitialized constant Module::Puppet

Associated revisions

Revision 7a744581 - 11/22/2012 10:39 AM - Dominic Cleal

fixes #1967 - missing require for Puppet constant

History

#1 - 11/22/2012 07:19 AM - Dominic Cleal

Could you try editing /usr/share/foreman-proxy/lib/puppetca_api.rb and changing these from line 67 It might give a better indication of the source.

rescue => e

log_halt 406, "Failed to list certificates: #{e}"
end
to
rescue => e
log_halt 406, "Failed to list certificates: #{e}: #{e.backtrace.join("\n")}"

end

#2 - 11/22/2012 07:58 AM -

E, [2012-11-22T16:44
uppet:

Dmitriy Novitskiy

:14.661608 #7848]

ERROR —- :

Failed to list certificates:
/usr/share/foreman-proxy/bin/../lib/proxy/puppetca.rb:103:in " find_puppetca’

/usr/share/foreman-proxy/bin/../lib/proxy/puppetca.rb:65:in "~ list'
/usr/share/foreman-proxy/bin/../lib/puppetca_api.rb:5:in

"GET /puppet/ca'

/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:863:in ‘call'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:863:in 'route'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:521:in " instance_eval'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:521:in "route_eval'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:500:in "route!'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:497:in "catch'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:497:in "route!'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:476:in ‘each'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:476:in “route!’
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:601:in “dispatch!’
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:411:in ‘call!'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:566:in " instance_eval'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:566:in " invoke'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:566:in ‘catch'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:566:in " invoke'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:411:in ‘call!'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:399:in “call’
/usr/lib/ruby/gems/1.8/gems/rack-1.4.1/1ib/rack/showexceptions.rb:24:in “call’
/usr/lib/ruby/gems/1.8/gems/rack-1.4.1/1ib/rack/commonlogger.rb:20:in “call"
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:979:in “call’
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:1005:in "synchronize'
/usr/lib/ruby/gems/1.8/gems/sinatra-1.0/1lib/sinatra/base.rb:979:in ‘call'
/usr/lib/ruby/gems/1.8/gems/rack-1.4.1/1lib/rack/handler/webrick.rb:59:in ‘service'
/usr/lib/ruby/1.8/webrick/httpserver.rb:104:in “service'
/usr/lib/ruby/1.8/webrick/httpserver.rb:65:in "run'

/usr/lib/ruby/1l.8/webrick/server.rb:173:in "start_thread'
/usr/lib/ruby/1.8/webrick/server.rb:162:in "start'
/usr/lib/ruby/1.8/webrick/server.rb:162:in 'start_thread'
/usr/lib/ruby/1.8/webrick/server.rb:95:in " start'
/usr/lib/ruby/1.8/webrick/server.rb:92:in “each'
/usr/lib/ruby/1.8/webrick/server.rb:92:in " start'
/usr/lib/ruby/1.8/webrick/server.rb:23:in " start'
/usr/lib/ruby/1.8/webrick/server.rb:82:in " start'

/usr/lib/ruby/gems/1.8/gems/rack-1.4.1/1ib/rack/handler/webrick.rb:13:in "run'
/usr/share/foreman-proxy/bin/../lib/sinatra-patch.rb:40:in “run!'
/usr/share/foreman-proxy/bin/smart-proxy:44

in 103 line:
103 if Puppet::PUPPETVERSION.to_i < 3
104 @puppetca = which ("puppetca", default_path) || which ("puppet", default_path)
105 else
106 @puppetca = which ("puppet", default_path)
107 end

Im applied this patch: https:/github.com/skottler/smart-proxy/commit/2594ef59ee5a88bfdda7aie8c3017845f1b5c3cd

#3 - 11/22/2012 08:04 AM - Dominic Cleal
Could you try adding require 'puppet' to the top of lib/proxy/puppetca.rb?

#4 - 11/22/2012 08:13 AM - Dmitriy Novitskiy

Hm, fix error when replace puppetca.rb with this file:
https://github.com/logicminds/smart-proxy/blob/223cc97fc3a1978d0882b52d951adc9bdb6d1044/lib/proxy/puppetca.rb

With this file: https:/github.com/skottler/smart-proxy/blob/2594ef59ee5a88bf9da7ale8c3017845f1b5c3cd/lib/proxy/puppetca.rb
Im got error

#5 - 11/22/2012 08:17 AM - Dmitriy Novitskiy

Could you try adding require 'puppet' to the top of lib/proxy/puppetca.rb?

help when added after line: module Proxy::PuppetCA
module Proxy::PuppetCA

extend Proxy::Log

extend Proxy::Util

require 'puppet’

When added on top - doest take effect
Thanks!

#6 - 11/22/2012 08:32 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

Thanks for confirming.

https://github.com/theforeman/smart-proxy/pull/43

#7 - 11/22/2012 10:39 AM - Ohad Levy

- Target version set to 1.1

#8 - 11/22/2012 04:51 PM - Dominic Cleal
https://github.com/skottler/smart-proxy/commit/2594ef59ee5a88bf9da7a1e8c3017845f1b5c3cd
https://github.com/logicminds/smart-proxy/blob/223cc97fc3a1978d0882b52d951adc9bdb6d1044/lib/proxy/puppetca.rb
https://github.com/skottler/smart-proxy/blob/2594ef59ee5a88bf9da7a1e8c3017845f1b5c3cd/lib/proxy/puppetca.rb
https://github.com/theforeman/smart-proxy/pull/43

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset 7a74458139368bce08bd16c5613f4691e2c22fed.
